header {
package edu.usfca.syndiag;
}
/** A tree grammar describing output of antlr.g's AST representing
 *  ANTLR grammars.
 *
 *  Terence Parr
 *  University of San Francisco
 *  August 19, 2003
 */
class ANTLRTreeDesc extends TreeParser;

options {
	importVocab = ANTLR;
    codeGenBitsetTestThreshold=999;
}

grammar
    :   classDef // ignore 2nd (lexer) grammar for now
    ;

classDef
    :   #( PARSER rules )
    |   #( TREE_PARSER rules )
    |   #( LEXER rules )
    ;

rules
    :   ( rule )+
    ;

rule
    :   #( RULE r:RULE_REF #(BLOCK block) EOR )
    ;

block
    :   ( alternative )+
    ;

alternative
    :   #( ALT (element)+ )
    ;

element
    :   atom
    |   #(NOT element) 
    |   #(TOKEN_RANGE atom atom)
    |   #(CHAR_RANGE CHAR_LITERAL CHAR_LITERAL)
    |   ebnf
    |   tree
    |   #( SYNPRED block )
    |   ACTION
    |   SEMPRED
    |   EPSILON
    ;

ebnf:   #( BLOCK block )
    |   #( OPTIONAL block )
    |   #( CLOSURE block )
    |   #( POSITIVE_CLOSURE block )
    ;

tree:   #(TREE_BEGIN atom (element)* )
    ;

atom
    :   RULE_REF
    |   TOKEN_REF
    |   CHAR_LITERAL
    |   STRING_LITERAL
    |   WILD_CARD
    ;

